%Script made to explore system intertia 
clear all, %close all

%Tappetest
filename_us = 'New data\Tappetest\Adb_1202_3p_30v_tappetest_1l_t2_us_signal.txt';
filename_trig = 'New data\Tappetest\Adb_1202_3p_30v_tappetest_1l_t2_us_trig.txt';

%Floater offset
% filename_us = 'New data\Floater offset\Adb_1202_3p_30v_floater_offset_t3_us_signal.txt';
% filename_trig = 'New data\Floater offset\Adb_1202_3p_30v_floater_offset_t3_us_trig.txt';

%Moving mrk test

us_data = dlmread(filename_us);
us_trig = dlmread(filename_trig);

%Formel for lydhastighet: C=1604.3+1.7948*T-0.0181*(T^2);

%Handle st_noise
l = size(us_data,1);
sample_l = size(us_data,2);
mean_val = mean(us_data(1,:));
st_noise = 700;
for i=1:l
    for j=1:st_noise
        us_data(i,j) = mean_val;
    end
end

us_data_n = normalize(us_data);
us_data_pr = us_data_n;

m_nr = size(us_data_pr,1);
delta_t = zeros(m_nr,1);
for i=1:m_nr
    [e_index] = echo_detection(us_data_pr(i,:),-1,-1);
    i
    %find echo_index with biggest value
    [~,main_e_ind] = max(e_index(:,1));
    %e_index is supposed  to return index inside of echo.
    [s_val,s_ind] = find_echo_start(us_data_pr(i,:),e_index(main_e_ind,2));
    delta_t(i) = s_ind;
    
%     figure(100)
%     plot(us_data_pr(i,:))
%     hold on
%     plot(s_ind,s_val,'r+')
%     pause(0.5)
%     hold off
    
    if i==22
       figure(110)
       plot(us_data_pr(i,:),'g','Linewidth',1)
       hold on
       plot(us_data_pr(i+1,:),'r','Linewidth',1)
       legend('Measurement n', 'Measurement n+1')
       xlabel('samples')
       ylabel('amplitude')
    end

end

c = 1630;
d = (delta_t/14.29e6)*c/2;
%Convert d to from m to cm
d  = 100*d;
if mod(m_nr,2) == 0
     time = 0:0.5:(m_nr-1)/2;
else
    time = 0:0.5:floor(m_nr/2);
end
d(1)-d(end)
%Floater offset plot
figure(101)
plot(time,d,'Linewidth',2)
hold on
xlabel('time in seconds')
ylabel('level in cm')

% ====================== AVERAGING AND PLOTTING ===========================

% av_mes = average_measurement2(us_data_pr,2);
% av_m_nr = size(av_mes,1);
% 
% for i=1:av_m_nr
%     figure(102)
%     plot(av_mes(i,delta_t(i)-300:delta_t(i)+300))
%     pause(0.5)
%     
% end
    

